unit DelForExReg;

interface

uses
  ToolsAPI;

// This function needs to be interface-visible, otherwise
// C++Builder 5 complains about a missing EXTDEF symbol
// for this export.  Do not call this function yourself.
function InitWizard(const BorlandIDEServices: IBorlandIDEServices;
  RegisterProc: TWizardRegisterProc;
  var Terminate: TWizardTerminateProc): Boolean; stdcall;

implementation

uses DelForExpert;

const
  InvalidIndex = -1;

var
  ExpertIndex: Integer = InvalidIndex;


// Remove the wizard when terminating.

procedure TerminateWizard;
var
  Services: IOTAWizardServices;
begin
  Services := BorlandIDEServices as IOTAWizardServices;
  Services.RemoveWizard(ExpertIndex);
end;


{ Register the wizard. }

function InitWizard(const BorlandIDEServices: IBorlandIDEServices;
  RegisterProc: TWizardRegisterProc;
  var Terminate: TWizardTerminateProc): Boolean; stdcall;
var
  WizardServices: IOTAWizardServices;
begin
  Result := (BorlandIDEServices <> nil);

  if Result then
    begin
      Assert(ToolsAPI.BorlandIDEServices = BorlandIDEServices);

      Terminate := TerminateWizard;

      WizardServices := BorlandIDEServices as IOTAWizardServices;
      Assert(Assigned(WizardServices));

      IDETextExpert := TIDETextExpert.Create;
      ExpertIndex := WizardServices.AddWizard(IDETextExpert as IOTAWizard);
      Result := (ExpertIndex >= 0);
    end;
end;

exports
  InitWizard name WizardEntryPoint;

end.

